import { ApolloProviderProviderConsumer } from "../../utils/provider";
export class ApolloMutationComponent {
    componentWillLoad() {
        this.passMutation();
    }
    onPropsChange() {
        this.passMutation();
    }
    async passMutation() {
        if (this.client) {
            this.mutationFn = args => this.client.mutate(Object.assign({ mutation: this.mutation, variables: this.variables }, this.options, args));
            this.readyEventEmitter.emit(this.mutationFn);
        }
        else {
            throw new Error('You should wrap your parent component with apollo-provider custom element or ApolloProvider functional component');
        }
    }
    render() {
        return this.renderer && this.renderer(this.mutationFn);
    }
    static get is() { return "apollo-mutation"; }
    static get properties() { return {
        "client": {
            "type": "Any",
            "attr": "client",
            "watchCallbacks": ["onPropsChange"]
        },
        "el": {
            "elementRef": true
        },
        "mutation": {
            "type": "Any",
            "attr": "mutation",
            "watchCallbacks": ["onPropsChange"]
        },
        "mutationFn": {
            "state": true
        },
        "options": {
            "type": "Any",
            "attr": "options",
            "watchCallbacks": ["onPropsChange"]
        },
        "renderer": {
            "type": "Any",
            "attr": "renderer",
            "watchCallbacks": ["onPropsChange"]
        },
        "variables": {
            "type": "Any",
            "attr": "variables",
            "watchCallbacks": ["onPropsChange"]
        }
    }; }
    static get events() { return [{
            "name": "ready",
            "method": "readyEventEmitter",
            "bubbles": true,
            "cancelable": true,
            "composed": true
        }]; }
}
ApolloProviderProviderConsumer.injectProps(ApolloMutationComponent, ['client']);
